window.addEventListener("load", function(e) { formhelp.onLoad(e); }, false);
var formhelp = {
	onLoad: function() {
		// initialization code
		// Get the "extensions.myext." branch
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				    getService(Components.interfaces.nsIPrefService);
		prefs = prefs.getBranch("extensions.FormHelp.");
		var bChecked = prefs.getBoolPref("FormHelp.alwaysactive"); // get a pref
		if(bChecked){
			document.getElementById('mybutton-2').setAttribute("checked",true);
			document.getElementById('mybutton-1').setAttribute("disabled",true);
		}
		
		var appcontent = document.getElementById("appcontent");   // browser
		if(appcontent) appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);
		
		this.initialized = true;
		this.strings = document.getElementById("formhelp-strings");
	},
	onMenuItemCommand: function(e) {
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
					  .getService(Components.interfaces.nsIPromptService);
		promptService.alert(window, this.strings.getString("helloMessageTitle"),
					this.strings.getString("helloMessage"));
		},
	onToolbarButtonCommand: function(e) {
		// just reuse the function above.  you can change this, obviously!
		formhelp.onMenuItemCommand(e);
	},
	onDoSwitch: function(tst) {
		var bChecked=!tst.checked;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
				    getService(Components.interfaces.nsIPrefService);
		prefs = prefs.getBranch("extensions.FormHelp.");
		prefs.setBoolPref("FormHelp.alwaysactive", bChecked); // set a pref
		if(bChecked) document.getElementById('mybutton-1').setAttribute("disabled",true);
		else document.getElementById('mybutton-1').setAttribute("disabled",false);
	},
	onDoNow: function() {
		if (content.document.FormHelped) return;
		content.document.FormHelped=true;
		var i=content.document.getElementsByTagName('input');
		for (var j=0; j<i.length; j++) {
			if ('hidden'==i[j].type) {
				i[j].type='';
				i[j].parentNode.insertBefore(newlabel(i[j].name + ': '),i[j]);
			}
			if ('password'==i[j].type) i[j].type='';
			i[j].removeAttribute('disabled');
			i[j].removeAttribute('readonly');
		}
		var i=content.document.getElementsByTagName('select');
		for (var j=0; j<i.length; j++) {
			i[j].removeAttribute('disabled');
		}
		var i=content.document.getElementsByTagName('form');
		for (var j=0; j<i.length; j++) {
			i[j].style.borderStyle = 'solid';
			i[j].style.borderColor = 'red';
			i[j].insertBefore(newlabel('Form-Action: ' + i[j].action,'Red'),i[j].firstChild);
		}
	},
	onPageLoad: function(aEvent) {
		var bActive = document.getElementById('mybutton-2').getAttribute("checked");
		content.document.FormHelped=false;
		if(bActive){
			var i=content.document.getElementsByTagName('input');
			for (var j=0; j<i.length; j++) {
				if ('hidden'==i[j].type) {
					i[j].type='';
					i[j].parentNode.insertBefore(newlabel(i[j].name + ': '),i[j]);
				}
				if ('password'==i[j].type) i[j].type='';
				i[j].removeAttribute('disabled');
				i[j].removeAttribute('readonly');
			}
			var i=content.document.getElementsByTagName('select');
			for (var j=0; j<i.length; j++) {
				i[j].removeAttribute('disabled');
			}
			var i=content.document.getElementsByTagName('form');
			for (var j=0; j<i.length; j++) {
				i[j].style.borderStyle = 'solid';
				i[j].style.borderColor = 'red';
				i[j].insertBefore(newlabel('Form-Action: ' + i[j].action,'Red'),i[j].firstChild);
			}
			content.document.FormHelped=true;
		}
	}

};

function newlabel(name){
	var label=content.document.createElement('label');
	label.innerHTML = name;
	return label;
}

function newlabel(name,color){
	var label=content.document.createElement('label');
	label.innerHTML = name;
	label.style.color=color;
	return label;
}

function newinput(name,type){
	var input=content.document.createElement('input');
	input.name=name;
	input.type=type;
	return input;
}

function add_form_buttons(){
	var i=content.document.getElementsByTagName('form');
	for (var j=0; j<i.length; j++) {
		i[j].insertBefore(newinput(i[j].name,'submit'),i[j].firstchild);
	}
}
